diff -crN nakedmudv1.4/src/inform.c nakedmudv1.5/src/inform.c
*** nakedmudv1.4/src/inform.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/inform.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 24,36 ****
  #include "inform.h"
  #include "log.h"
  
- 
  // optional module headers
  #ifdef MODULE_TIME
  #include "time/mudtime.h"
  #endif
  
  
  //
  // Show a character who is all sitting at one piece of furniture
  //
--- 24,41 ----
  #include "inform.h"
  #include "log.h"
  
  // optional module headers
  #ifdef MODULE_TIME
  #include "time/mudtime.h"
  #endif
  
  
+ //*****************************************************************************
+ //
+ // local functions
+ //
+ //*****************************************************************************
+ 
  //
  // Show a character who is all sitting at one piece of furniture
  //
***************
*** 92,97 ****
--- 97,133 ----
  }
  
  
+ //
+ // uhhh... "contents" isn't really the right word, since we list both
+ // objects AND characters. Alas, my lexicon is not as verbose as it
+ // could be.
+ //
+ void list_room_contents(CHAR_DATA *ch, ROOM_DATA *room) {
+   LIST *list = NULL;
+ 
+   list = get_nofurniture_chars(ch, roomGetCharacters(room), FALSE, FALSE);
+   show_list(ch, list, charGetRdesc, charGetMultiRdesc, charGetVnum);
+   deleteList(list);
+ 
+   // show all of the objects that have people using them
+   list = get_used_items(ch, roomGetContents(room), FALSE);
+   list_used_furniture(ch, list);
+   deleteList(list);
+ 
+   // show all of the objects that don't have people using them that we can see
+   list = get_unused_items(ch, roomGetContents(room), FALSE);
+   show_list(ch, list, objGetRdesc, objGetMultiRdesc, objGetVnum);
+   deleteList(list);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementaiton of inform.h
+ // look_at_xxx and show_xxx functions.
+ //
+ //*****************************************************************************
  void look_at_obj(CHAR_DATA *ch, OBJ_DATA *obj) {
    char *new_desc = tagEdescs(objGetEdescs(obj),
  			     objGetDesc(obj),
***************
*** 113,119 ****
        // make sure we can still see things
        if(listSize(vis_contents) > 0) {
  	send_to_char(ch, "It contains:\r\n");
! 	show_list(ch, vis_contents, objGetName, objGetMultiName);
        }
        deleteList(vis_contents);
      }
--- 149,155 ----
        // make sure we can still see things
        if(listSize(vis_contents) > 0) {
  	send_to_char(ch, "It contains:\r\n");
! 	show_list(ch, vis_contents, objGetName, objGetMultiName, objGetVnum);
        }
        deleteList(vis_contents);
      }
***************
*** 151,158 ****
  
  
  void look_at_exit(CHAR_DATA *ch, EXIT_DATA *exit) {
!   send_to_char(ch, "%s", (*exitGetDesc(exit) ? exitGetDesc(exit) :
! 			  NOTHING_SPECIAL"\r\n"));
    // we have a door ... gotta print it's status
    if(exitIsClosable(exit)) {
      if(!*exitGetName(exit))
--- 187,194 ----
  
  
  void look_at_exit(CHAR_DATA *ch, EXIT_DATA *exit) {
!   send_to_char(ch, "{g%s", (*exitGetDesc(exit) ? exitGetDesc(exit) :
! 			    NOTHING_SPECIAL"\r\n"));
    // we have a door ... gotta print it's status
    if(exitIsClosable(exit)) {
      if(!*exitGetName(exit))
***************
*** 162,167 ****
--- 198,210 ----
  		   exitGetName(exit), (exitIsClosed(exit) ? "closed":"open"));
      }
    }
+ 
+   // the door is not closed, list off the people we can see as well
+   if(!exitIsClosed(exit)) {
+     ROOM_DATA *room = worldGetRoom(gameworld, exitGetTo(exit));
+     if(room != NULL)
+       list_room_contents(ch, room);
+   }
  }
  
  
***************
*** 178,188 ****
      if(!can_see_exit(ch, exit))
        continue;
      else if((to = worldGetRoom(gameworld, exitGetTo(exit))) == NULL) {
!        log_string("ERROR: room %d heads %s to room %d, which does not exist.",
  		 roomGetVnum(room), dirGetName(i), exitGetTo(exit));
!        continue;
      }
! 
      if(charGetLevel(ch) > LEVEL_PLAYER)
        sprintf(buf, "[%d] ", roomGetVnum(to));
      else
--- 221,231 ----
      if(!can_see_exit(ch, exit))
        continue;
      else if((to = worldGetRoom(gameworld, exitGetTo(exit))) == NULL) {
!       log_string("ERROR: room %d heads %s to room %d, which does not exist.",
  		 roomGetVnum(room), dirGetName(i), exitGetTo(exit));
!       continue;
      }
!     
      if(charGetLevel(ch) > LEVEL_PLAYER)
        sprintf(buf, "[%d] ", roomGetVnum(to));
      else
***************
*** 201,207 ****
  
    // list special exits
    int num_spec_exits = 0;
!   char **names = roomGetExitNames(room, &num_spec_exits);
    for(i = 0; i < num_spec_exits; i++) {
      if((exit = roomGetExitSpecial(room, names[i])) == NULL)
        continue;
--- 244,250 ----
  
    // list special exits
    int num_spec_exits = 0;
!   const char **names = roomGetExitNames(room, &num_spec_exits);
    for(i = 0; i < num_spec_exits; i++) {
      if((exit = roomGetExitSpecial(room, names[i])) == NULL)
        continue;
***************
*** 228,236 ****
  		  roomGetName(to)));
    }
  
    // clean up our mess
-   for(i = 0; i < num_spec_exits; i++)
-     free(names[i]);
    free(names);
  }
  
--- 271,278 ----
  		  roomGetName(to)));
    }
  
+ 
    // clean up our mess
    free(names);
  }
  
***************
*** 259,267 ****
    show_body(ch, charGetBody(vict));
  }
  
- void look_at_room(CHAR_DATA *ch, ROOM_DATA *room) {
-   LIST *list = NULL;
  
    if(charGetLevel(ch) > LEVEL_PLAYER)
      send_to_char(ch, "{c[%d] ", roomGetVnum(room));
  
--- 301,308 ----
    show_body(ch, charGetBody(vict));
  }
  
  
+ void look_at_room(CHAR_DATA *ch, ROOM_DATA *room) {
    if(charGetLevel(ch) > LEVEL_PLAYER)
      send_to_char(ch, "{c[%d] ", roomGetVnum(room));
  
***************
*** 272,301 ****
    if((is_evening() || is_night()) && *roomGetNightDesc(room))
      desc = roomGetNightDesc(room);
  #endif
- 
    char *colorize_desc = tagEdescs(roomGetEdescs(room), desc, "{c", "{g");
    send_to_char(ch, "{g%s", colorize_desc);
!   if(colorize_desc) free(colorize_desc);
! 
    list_room_exits(ch, room);
!   list = get_nofurniture_chars(ch, roomGetCharacters(room), FALSE, FALSE);
!   show_list(ch, list, charGetRdesc, charGetMultiRdesc);
!   deleteList(list);
! 
!   // show all of the objects that have people using them
!   list = get_used_items(ch, roomGetContents(room), FALSE);
!   list_used_furniture(ch, list);
!   deleteList(list);
! 
!   // show all of the objects that don't have people using them that we can see
!   list = get_unused_items(ch, roomGetContents(room), FALSE);
!   show_list(ch, list, objGetRdesc, objGetMultiRdesc);
!   deleteList(list);
  
    send_to_char(ch, "{n");
  };
  
  
  void send_outdoors(const char *format, ...) {
    if(format && *format) {
      // form the message
--- 313,336 ----
    if((is_evening() || is_night()) && *roomGetNightDesc(room))
      desc = roomGetNightDesc(room);
  #endif
    char *colorize_desc = tagEdescs(roomGetEdescs(room), desc, "{c", "{g");
    send_to_char(ch, "{g%s", colorize_desc);
!   free(colorize_desc);
!     
    list_room_exits(ch, room);
!   list_room_contents(ch, room);
  
    send_to_char(ch, "{n");
  };
  
  
+ 
+ //*****************************************************************************
+ //
+ // implementaiton of inform.h
+ // send_to_xxx functions
+ //
+ //*****************************************************************************
  void send_outdoors(const char *format, ...) {
    if(format && *format) {
      // form the message
***************
*** 309,315 ****
      LIST_ITERATOR *list_i = newListIterator(mobile_list);
      CHAR_DATA *ch = NULL;
      ITERATE_LIST(ch, list_i)
!       if(roomGetTerrain(charGetRoom(ch)) != TERRAIN_INDOORS)
  	text_to_char(ch, buf);
      deleteListIterator(list_i);
    }
--- 344,351 ----
      LIST_ITERATOR *list_i = newListIterator(mobile_list);
      CHAR_DATA *ch = NULL;
      ITERATE_LIST(ch, list_i)
!       if(roomGetTerrain(charGetRoom(ch)) != TERRAIN_INDOORS &&
! 	 roomGetTerrain(charGetRoom(ch)) != TERRAIN_CAVERN)
  	text_to_char(ch, buf);
      deleteListIterator(list_i);
    }
***************
*** 404,413 ****
  
  
  
- 
  //*****************************************************************************
  //
! // commands included in inform.c
  //
  //*****************************************************************************
  
--- 440,449 ----
  
  
  
  //*****************************************************************************
  //
! // implementation of inform.h
! // game commands
  //
  //*****************************************************************************
  
***************
*** 503,509 ****
  	send_to_char(ch, "You peer inside of %s:\r\n", objGetName(found));
  	LIST *vis_objs = find_all_objs(ch, objGetContents(found), "",
  				       NOTHING, TRUE);
! 	show_list(ch, vis_objs, objGetName, objGetMultiName);
  	deleteList(vis_objs);
        }
      }
--- 539,545 ----
  	send_to_char(ch, "You peer inside of %s:\r\n", objGetName(found));
  	LIST *vis_objs = find_all_objs(ch, objGetContents(found), "",
  				       NOTHING, TRUE);
! 	show_list(ch, vis_objs, objGetName, objGetMultiName, objGetVnum);
  	deleteList(vis_objs);
        }
      }
***************
*** 540,546 ****
    else {
      send_to_char(ch, "You are carrying:\r\n");
      LIST *vis_objs = find_all_objs(ch, charGetInventory(ch), "", NOTHING, TRUE);
!     show_list(ch, vis_objs, objGetName, objGetMultiName);
      deleteList(vis_objs);
    }
  }
--- 576,582 ----
    else {
      send_to_char(ch, "You are carrying:\r\n");
      LIST *vis_objs = find_all_objs(ch, charGetInventory(ch), "", NOTHING, TRUE);
!     show_list(ch, vis_objs, objGetName, objGetMultiName, objGetVnum);
      deleteList(vis_objs);
    }
  }
***************
*** 592,628 ****
  }
  
  
- //
- // show the character the contents of a specific helpfile, or all the helpfiles
- // available if no argument is supplied.
- //
- COMMAND(cmd_help)
- {
-   if (arg[0] == '\0')
-   {
-     HELP_DATA *pHelp;
-     BUFFER *buf = buffer_new(MAX_BUFFER);
-     int col = 0;
- 
-     bprintf(buf, "      - - - - - ----====//// HELP FILES  \\\\\\\\====---- - - - - -\n\n\r");
-     for (pHelp = help_list; pHelp; pHelp = pHelp->next)
-     {
-       bprintf(buf, " %-19.18s", pHelp->keyword);
-       if (!(++col % 4)) bprintf(buf, "\n\r");
-     }
-     if (col % 4) bprintf(buf, "\n\r");
-     bprintf(buf, "\n\r Syntax: help <topic>\n\r");
-     text_to_char(ch, buf->data);
-     buffer_free(buf);
-     return;
-   }
-   if (!check_help(ch, arg))
-   {
-     text_to_char(ch, "Sorry, no such helpfile.\n\r");
-     return;
-   }
- }
- 
  
  //*****************************************************************************
  //
--- 628,633 ----
diff -crN nakedmudv1.4/src/interpret.c nakedmudv1.5/src/interpret.c
*** nakedmudv1.4/src/interpret.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/interpret.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 91,99 ****
    // B
    add_cmd("back",       NULL, cmd_back,     0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
!   add_cmd("buildwalk",  NULL, cmd_tog_prf,  SUBCMD_BUILDWALK, 
  	  POS_UNCONCIOUS, POS_FLYING, LEVEL_BUILDER, FALSE, FALSE);
  
    // C
    add_cmd("chat",       NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
--- 91,100 ----
    // B
    add_cmd("back",       NULL, cmd_back,     0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
!   add_cmd("buildwalk",  NULL, cmd_tog_prf,  PRF_BUILDWALK, 
  	  POS_UNCONCIOUS, POS_FLYING, LEVEL_BUILDER, FALSE, FALSE);
  
+ 
    // C
    add_cmd("chat",       NULL, cmd_chat,     0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
***************
*** 149,160 ****
  	  LEVEL_BUILDER, FALSE, TRUE );
  
    // H
!   add_cmd("help",       NULL, cmd_help,     0, POS_UNCONCIOUS, POS_FLYING,
! 	  LEVEL_PLAYER, TRUE, FALSE);
  
    // I
    add_cmd("inventory",  NULL, cmd_inventory,0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
  
    // L
    add_cmd("look",       "l",  cmd_look,     0, POS_SITTING,  POS_FLYING,
--- 150,163 ----
  	  LEVEL_BUILDER, FALSE, TRUE );
  
    // H
!   //  add_cmd("help",       NULL, cmd_help,     0, POS_UNCONCIOUS, POS_FLYING,
!   //	  LEVEL_PLAYER, TRUE, FALSE);
  
    // I
    add_cmd("inventory",  NULL, cmd_inventory,0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
+   add_cmd("invis",      NULL, cmd_invis,    0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, FALSE);
  
    // L
    add_cmd("look",       "l",  cmd_look,     0, POS_SITTING,  POS_FLYING,
***************
*** 169,174 ****
--- 172,179 ----
  	  LEVEL_ADMIN, FALSE, FALSE);
  
    // M
+   add_cmd("mapwalk",    NULL, cmd_tog_prf,  PRF_MAPWALK,
+ 	  POS_UNCONCIOUS, POS_FLYING, LEVEL_PLAYER, FALSE, FALSE);
    add_cmd("mlist",      NULL, cmd_mlist,    0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_BUILDER, FALSE, FALSE);
    add_cmd("more",       NULL, cmd_more,     0, POS_UNCONCIOUS, POS_FLYING,
***************
*** 211,216 ****
--- 216,223 ----
  	  LEVEL_PLAYER, TRUE, FALSE);
    add_cmd("stand",      NULL, cmd_stand,    0, POS_SITTING,  POS_STANDING,
  	  LEVEL_PLAYER, TRUE, TRUE );
+   add_cmd("stop",       NULL, cmd_stop,     0, POS_SITTING, POS_FLYING,
+ 	  LEVEL_PLAYER, TRUE, FALSE);
  #ifdef MODULE_SCRIPTS
    // really, we -should- put this in the scripts module, but there are some
    // very nice functions in builder.c that cmd_sclist uses to print scripts,
***************
*** 224,234 ****
--- 231,247 ----
  	  LEVEL_PLAYER, TRUE, TRUE );
    add_cmd("tell",       NULL, cmd_tell,     0, POS_SLEEPING, POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
+   add_cmd("transfer",   NULL, cmd_transfer, 0, POS_STANDING, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, TRUE);
  
    // U
    add_cmd("unlock",       NULL,  cmd_unlock,    0, POS_STANDING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, TRUE);
  
+   // V
+   add_cmd("visible",      NULL, cmd_visible,    0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, FALSE);
+ 
    // W
    add_cmd("wake",       NULL, cmd_wake,     0, POS_SLEEPING,  POS_SLEEPING,
  	  LEVEL_PLAYER, TRUE, TRUE );
***************
*** 240,245 ****
--- 253,260 ----
  	  LEVEL_BUILDER, FALSE, FALSE);
    add_cmd("worn",       NULL, cmd_equipment,0, POS_SITTING,  POS_FLYING,
  	  LEVEL_PLAYER, TRUE, FALSE);
+   add_cmd("write",      NULL, cmd_write,    0, POS_SITTING, POS_FLYING,
+ 	  LEVEL_PLAYER, TRUE, TRUE);
  
    // Z
    add_cmd("zlist",      NULL, cmd_zlist,    0, POS_SITTING,  POS_FLYING,
diff -crN nakedmudv1.4/src/io.c nakedmudv1.5/src/io.c
*** nakedmudv1.4/src/io.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/io.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 81,102 ****
    communicate(NULL, buf, COMM_LOG);
  }
  
- /*
-  * This function will return the time of
-  * the last modification made to helpfile.
-  */
- time_t last_modified(char *helpfile)
- {
-   char fHelp[256];
-   struct stat sBuf;
-   time_t mTime = 0;
- 
-   sprintf(fHelp, "../help/%s", helpfile);
-   if (stat(fHelp, &sBuf) >= 0)
-     mTime = sBuf.st_mtime;
- 
-   return mTime;
- }
  
  char *read_file(const char *file) {
    FILE *fl;
--- 81,86 ----
***************
*** 116,159 ****
  }
  
  
- char *read_help_entry(const char *helpfile)
- {
-   FILE *fp;
-   static char entry[MAX_BUFFER];
-   char fHelp[256];
-   int c, ptr = 0;
- 
-   /* location of the help file */
-   sprintf(fHelp, "../help/%s", helpfile);
- 
-   /* if there is no help file, return NULL */
-   if ((fp = fopen(fHelp, "r")) == NULL)
-     return NULL;
- 
-   /* just to have something to work with */
-   c = getc(fp);
- 
-   /* read the file in the buffer */
-   while (c != EOF)
-   {
-     if (c == '\n')
-       entry[ptr++] = '\r';
-     entry[ptr] = c;
-     if (++ptr > MAX_BUFFER - 2)
-     {
-       bug("Read_help_entry: String to long.");
-       abort();
-     }
-     c = getc(fp);
-   }
-   entry[ptr] = '\0';
- 
-   fclose(fp);
- 
-   /* return a pointer to the static buffer */
-   return entry;
- }
- 
  /*
   * Reads one line from a file, and returns a
   * pointer to a _static array_ holding the line.
--- 100,105 ----
diff -crN nakedmudv1.4/src/list.c nakedmudv1.5/src/list.c
*** nakedmudv1.4/src/list.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/list.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 283,288 ****
--- 283,296 ----
    return (node ? node->elem : NULL);
  }
  
+ void *listHead(struct list *L) {
+   return L->head;
+ }
+ 
+ void *listTail(struct list *L) {
+   return L->tail;
+ }
+ 
  int isListEmpty(struct list *L) {
    return (L->size == 0);
  }
diff -crN nakedmudv1.4/src/list.h nakedmudv1.5/src/list.h
*** nakedmudv1.4/src/list.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/list.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 95,100 ****
--- 95,112 ----
  
  
  //
+ // Return the head of the list
+ //
+ void *listHead(struct list *L);
+ 
+ 
+ //
+ // Return the tail of the list
+ //
+ void *listTail(struct list *L);
+ 
+ 
+ //
  // Put the element in the list in an ascending order, based on
  // what the comparator, func, tells us is the order.
  //
diff -crN nakedmudv1.4/src/log.c nakedmudv1.5/src/log.c
*** nakedmudv1.4/src/log.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/log.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 70,80 ****
    const char *log   = NULL;
    const char *words = NULL;
  
!   store_list(set, "logs", log_list, NULL);
    ITERATE_HASH(log, words, hash_i) {
      STORAGE_SET *one_log = new_storage_set();
!     store_string(one_log, "log",      log,   NULL);
!     store_string(one_log, "keywords", words, NULL);
      storage_list_put(log_list, one_log);
    }
    deleteHashIterator(hash_i);
--- 70,80 ----
    const char *log   = NULL;
    const char *words = NULL;
  
!   store_list(set, "logs", log_list);
    ITERATE_HASH(log, words, hash_i) {
      STORAGE_SET *one_log = new_storage_set();
!     store_string(one_log, "log",      log);
!     store_string(one_log, "keywords", words);
      storage_list_put(log_list, one_log);
    }
    deleteHashIterator(hash_i);
